package filesystem

import (
	"fmt"
	"log"
	"os"
)

var files []*os.File

func Read(fileName string, fileType string) {
	fileTypeEnding := ""
	switch fileType {
	case "verilog":
		fileName = "../verilog/" + fileName
		fileTypeEnding = ".v"
	default:
		fmt.Println("Error, missing/wrong filetype")
		return
	}

	file, err := os.OpenFile(
		fileName+fileTypeEnding,
		os.O_WRONLY|os.O_TRUNC|os.O_CREATE,
		0666,
	)
	if err != nil {
		log.Fatal(err)
	}
	defer file.Close()

	// Write bytes to file
	file.Read()

	bytes, err := file.Write(byteSlice)
	if err != nil {
		log.Fatal(err)
	}
	log.Printf("Wrote %d bytes.\n", bytesWritten)

}

func Write(fileName string, fileType string, data string) {
	fileTypeEnding := ""
	switch fileType {
	case "verilog":
		fileName = "../verilog/" + fileName
		fileTypeEnding = ".v"
	default:
		fmt.Println("Error, missing/wrong filetype")
		return
	}

	file, err := os.OpenFile(
		fileName+fileTypeEnding,
		os.O_WRONLY|os.O_TRUNC|os.O_CREATE,
		0666,
	)
	if err != nil {
		log.Fatal(err)
	}
	defer file.Close()

	// Write bytes to file
	byteSlice := []byte(data)
	bytesWritten, err := file.Write(byteSlice)
	if err != nil {
		log.Fatal(err)
	}
	log.Printf("Wrote %d bytes.\n", bytesWritten)

}

func Save() {

}

func New(fileName string, fileType string) {
	fileTypeEnding := ""
	switch fileType {
	case "verilog":
		fileName = "../verilog/" + fileName
		fileTypeEnding = ".v"
	default:
		fmt.Println("Error, missing/wrong filetype")
		return
	}
	newFile, err := os.Create(fileName + fileTypeEnding)
	if err != nil {
		fmt.Println(err)
		return
	}
	files = append(files, newFile)
}

func Delete() {

}
